@echo off
REM
REM applyPatch.cmd
REM 
REM (C) Copyright IBM Corp. 1998, 2003
REM ALL RIGHTS RESERVED
REM Tivoli Software
REM
REM The source code for this program is not published or otherwise divested
REM of its trade secrets, irrespective of what has been deposited with the
REM U.S. Copyright Office.
REM

IF "%1"=="" goto USAGE
IF "%2"=="" goto USAGE

SET ORIGIN_FILE=.\%1
SET PATCH_NAME=%2

IF "%3"=="UNINSTALL" GOTO UNINSTALL
SET NONBINFILE=%3
SET NONBINDEST=%4
GOTO DETERMINEBINFILE

:UNINSTALL
SET NONBINFILE=%4
SET NONBINDEST=%5

:DETERMINEBINFILE
IF "%NONBINFILE%"=="" GOTO BINFILE
SET BASE_DIR=%~dp$PATH:1
IF NOT EXIST "%BASE_DIR%" 		GOTO DIR_ERROR
SET DEST_FILE=%BASE_DIR%%NONBINDEST%\%NONBINFILE%
SET ORIGIN_FILE=.\%NONBINFILE%
SET BACKUP_FILE=%DEST_FILE%.%PATCH_NAME%
GOTO CONTINUE

:BINFILE
SET DEST_FILE=%~$PATH:1
SET BACKUP_FILE=%DEST_FILE%.%PATCH_NAME%
IF NOT EXIST "%DEST_FILE%" 		GOTO DEST_FILE_ERROR
GOTO CONTINUE

:CONTINUE
IF "%3"=="UNINSTALL" GOTO ROLLBACK
IF NOT EXIST "%ORIGIN_FILE%"	GOTO ORIGIN_FILE_ERROR
IF EXIST "%BACKUP_FILE%" 		GOTO ALREADY_APPLIED

echo Backing up %DEST_FILE% as %BACKUP_FILE%
copy "%DEST_FILE%" "%BACKUP_FILE%"
IF %ErrorLevel% GTR 0 GOTO GENERIC_ERROR

echo Updating patched file: %DEST_FILE%
copy "%ORIGIN_FILE%" "%DEST_FILE%"
IF %ErrorLevel% GTR 0 GOTO GENERIC_ERROR

echo %PATCH_NAME% for file %DEST_FILE% applied
SET LOCALERRORLEVEL=0
GOTO FIN

:ROLLBACK
IF NOT EXIST "%DEST_FILE%"	GOTO DEST_FILE_ERROR
IF NOT EXIST "%BACKUP_FILE%" GOTO UNAPPLIED_ERROR
echo Deleting %DEST_FILE%
del "%DEST_FILE%"
IF %ErrorLevel% GTR 0 GOTO GENERIC_ERROR
echo Rollback will move %BACKUP_FILE% to %DEST_FILE%
move "%BACKUP_FILE%" "%DEST_FILE%"
IF %ErrorLevel% GTR 0 GOTO GENERIC_ERROR

echo Uninstall of %PATCH_NAME% for file %DEST_FILE% completed
SET LOCALERRORLEVEL=0
GOTO FIN

:USAGE
echo.
echo Usage: applyPatch ^<BINFILE^> ^<APAR^> [UNINSTALL]
echo        applyPatch ^<REFFILE^> ^<APAR^> [UNINSTALL] [NONBINFILE] [DESTINATION]
SET LOCALERRORLEVEL=1
GOTO FIN

:UNAPPLIED_ERROR
echo The file %BACKUP_FILE% does not exists.
echo This patch can not be uninstalled.
SET LOCALERRORLEVEL=1
GOTO FIN

:ALREADY_APPLIED
echo The file %BACKUP_FILE% exists.
echo This patch has already been applied. 
echo To rollback changes, stop endpoint services and restore files from
echo backed up files named FILE.PATCH_NAME.
SET LOCALERRORLEVEL=1
GOTO FIN

:DIR_ERROR
if "%BASE_DIR" == "" echo Invalid PATH detected
echo The directory %BASE_DIR% does not exist.
echo Verify the install location of the STI endpoint and try again.
SET LOCALERRORLEVEL=2
GOTO FIN

:DEST_FILE_ERROR
if "%DEST_FILE%" == "" echo Invalid PATH Detected
echo Destination file [%DEST_FILE%] does not exist, or %1 is not in PATH.
SET LOCALERRORLEVEL=3
GOTO FIN

:ORIGIN_FILE_ERROR
echo Origin file %ORIGIN_FILE% does not exist.
SET LOCALERRORLEVEL=4
GOTO FIN

:GENERIC_ERROR
echo An error has occurred and the script aborted: ERRORLEVEL=%ERRORLEVEL%
SET LOCALERRORLEVEL=5
GOTO FIN

:FIN
